library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.global.all;

entity top is
  port (
    pClk   : in  std_logic;
    pRxD   : in  std_logic;
    pTxD   : out std_logic;
    pReset : in  std_logic
    );
end top;

architecture RTL of top is

  component reversi
    generic (
      sys_clk : integer := 50000000;
      rate : integer    := 19200;
      MAX_TRY_NUM       : integer := 2000
      );
    port (
      pClk   : in  std_logic;
      pRxD   : in  std_logic;
      pTxD   : out std_logic;
      pReset : in  std_logic
      );
  end component;

begin  -- RTL

  U: reversi
    generic map(
      sys_clk => 40000000,
      rate    => 19200,
      MAX_TRY_NUM => 2000
      )
    port map(
      pClk   => pClk,
      pRxD   => pRxD,
      pTxD   => pTxD,
      pReset => pReset
      );

end RTL;
