--
-- e_Ԃ邩ǂ肷
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.global.all;

entity judge is
  generic (
    x : integer := 0;
    y : integer := 0
    );
  port (
    Ax : in std_logic_vector(2 downto 0);
    Ay : in std_logic_vector(2 downto 0);
    Turn : in GameTurn;
    BlackData : in std_logic_vector(63 downto 0);
    WhiteData : in std_logic_vector(63 downto 0);
    result : out std_logic
    );
end judge;

architecture rtl of judge is

  constant cX : std_logic_vector(2 downto 0) := conv_std_logic_vector(x, 3);
  constant cY : std_logic_vector(2 downto 0) := conv_std_logic_vector(y, 3);

  constant id : integer := x * 8 + y;

  signal SameColorData     : std_logic_vector(63 downto 0);
  signal OppositeColorData : std_logic_vector(63 downto 0);
  
begin  -- rtl

  process(Turn, WhiteData, BlackData)
  begin
    if Turn = WHITE then
      SameColorData <= BlackData;
      OppositeColorData <= WhiteData;
    else
      SameColorData <= WhiteData;
      OppositeColorData <= BlackData;
    end if;
  end process;
  
  process(Ax, Ay, WhiteData, BlackData, SameColorData, OppositeColorData)
    variable FillFlag : std_logic;
    variable OppositeX : integer range 0 to 8;
    variable OppositeY : integer range 0 to 8;
  begin
    --------------------------------------------------------------------
    -- Ԃ̑Ώۂ̐΂Ȃꍇ
    --------------------------------------------------------------------
    if SameColorData(id) = '0' then
      result <= '0';
    --------------------------------------------------------------------
    -- ł_Ɠꍇ
    --------------------------------------------------------------------
    elsif (Ax = Cx) and (Ay = Cy) then
      result <= '0';
    --------------------------------------------------------------------
    -- XWC̎㑤ɐ΂łꂽP[X
    --------------------------------------------------------------------
    elsif Ax = Cx and Ay < Cy then
      FillFlag := '1';
      OppositeY := 8;
      for i in 7 downto 0 loop        -- 傫猟
        if y < i then                 -- Ό̗̈
          if(OppositeColorData(x * 8 + i) = '1') then
            OppositeY := i;
          end if;
        end if;
      end loop;
      -- ԂSēFł邩ǂ
      for i in 0 to 7 loop
        if (conv_integer(Ay) < i) and (i < y) then
          if(SameColorData(x * 8 + i) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      for i in 0 to 7 loop
        if (y < i) and (i < OppositeY) then
          if(SameColorData(x * 8 + i) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      if (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    ----------------------------------------------------------------------
    -- XWC̎艺ɐ΂łꂽP[X
    ----------------------------------------------------------------------
    elsif Ax = Cx and Ay > Cy then
      FillFlag := '1';
      OppositeY := 8;
      for i in 0 to 7 loop        -- 猟
        if i < y then                 -- Ό̗̈
          if(OppositeColorData(x * 8 + i) = '1') then
            OppositeY := i;
          end if;
        end if;
      end loop;
      -- ԂSēFł邩ǂ
      for i in 0 to 7 loop
        if (OppositeY < i) and (i < y) then
          if(SameColorData(x * 8 + i) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      for i in 0 to 7 loop
        if (y < i) and (i < conv_integer(Ay)) then
          if(SameColorData(x * 8 + i) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      if (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- YW̎荶ɐ΂łꂽP[X
    --------------------------------------------------------------------
    elsif Ay = Cy and Ax < Cx then
      FillFlag := '1';
      OppositeX := 8;
      for i in 7 downto 0 loop        -- 傫猟
        if x < i then                 -- Ό̗̈
          if(OppositeColorData(i * 8 + y) = '1') then
            OppositeX := i;
          end if;
        end if;
      end loop;
      -- ԂSēFł邩ǂ
      for i in 0 to 7 loop
        if (conv_integer(Ax) < i) and (i < x) then
          if(SameColorData(i * 8 + y) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      for i in 0 to 7 loop
        if (x < i) and (i < OppositeX) then
          if(SameColorData(i * 8 + y) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      if (OppositeX /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- YW̎Eɐ΂łꂽP[X
    --------------------------------------------------------------------
    elsif Ay = Cy and Ax > Cx then
      FillFlag := '1';
      OppositeX := 8;
      for i in 0 to 7 loop        -- 猟
        if i < x then                 -- Ό̗̈
          if(OppositeColorData(i * 8 + x) = '1') then
            OppositeX := i;
          end if;
        end if;
      end loop;
      -- ԂSēFł邩ǂ
      for i in 0 to 7 loop
        if (OppositeX < i) and (i < x) then
          if(SameColorData(i * 8 + y) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      for i in 0 to 7 loop
        if (x < i) and (i < conv_integer(Ax)) then
          if(SameColorData(i * 8 + y) = '0') then
            FillFlag := '0';
          end if;
        end if;
      end loop;
      if (OppositeX /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- ɑłꂽꍇ
    --------------------------------------------------------------------
    elsif ((Ay + Cx) = (Ax + Cy)) and (Ax < Cx and Ay < Cy) then
      FillFlag := '1';
      OppositeX := 8;
      OppositeY := 8;
      -- ET 
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (x < i) and (y < j) and ((x + j) = (y + i)) then
            if(OppositeColorData(i*8+j) = '1') then
              OppositeX := i;
              OppositeY := j;
            end if;
          end if;
        end loop;
      end loop;
      -- ܂΂Ƃ̊ԂׂēF
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (conv_integer(Ax) < i) and (i < x) and (conv_integer(Ay) < j)  and (j < y) and (x + j = y + i) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (x < i) and (i < OppositeX) and (y < j) and (j < OppositeY) and (x + j = y + i) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      if (OppositeX /= 8) and (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- Eɑłꂽꍇ
    --------------------------------------------------------------------
    elsif ((Ay + Cx) = (Ax + Cy)) and (Ax > Cx and Ay > Cy) then
      FillFlag := '1';
      OppositeX := 8;
      OppositeY := 8;
      -- ォT 
      for i in 0 to 7 loop
        for j in 0 to 7 loop
          if (i < x) and (j < y) and ((x + j) = (y + i)) then
            if(OppositeColorData(i*8+j) = '1') then
              OppositeX := i;
              OppositeY := j;
            end if;
          end if;
        end loop;
      end loop;
      -- ܂΂Ƃ̊ԂׂēF
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (OppositeX < i) and (i < x) and (OppositeY < j) and (j < y) and (x + j = y + i) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (x < i) and (i < conv_integer(Ax)) and (y < j) and (j < conv_integer(Ay)) and (x + j = y + i) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      if (OppositeX /= 8) and (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- Eɑłꂽꍇ
    --------------------------------------------------------------------
    elsif ((Ax + Ay) = (Cx + Cy)) and (Ax > Cx and Ay < Cy) then
      FillFlag := '1';
      OppositeX := 8;
      OppositeY := 8;
      -- T 
      for i in 0 to 7 loop
        for j in 7 downto 0 loop
          if (i < x) and (y < j) and ((x + y) = (i + j)) then
            if(OppositeColorData(i*8+j) = '1') then
              OppositeX := i;
              OppositeY := j;
            end if;
          end if;
        end loop;
      end loop;
      -- ܂΂Ƃ̊ԂׂēF
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (x < i) and (i < conv_integer(Ax)) and (conv_integer(Ay) < j) and (j < y) and (x + y = i + j) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (OppositeX < i) and (i < x) and (y < j) and (j < OppositeY) and (x + y = i + j) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      if (OppositeX /= 8) and (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- ɑłꂽꍇ
    --------------------------------------------------------------------
    elsif ((Ax + Ay) = (Cx + Cy)) and (Ax < Cx and Ay > Cy) then
      FillFlag := '1';
      OppositeX := 8;
      OppositeY := 8;
      -- EォT 
      for i in 7 downto 0 loop
        for j in 0 to 7 loop
          if (x < i) and (j < y) and ((x + y) = (i + j)) then
            if(OppositeColorData(i*8+j) = '1') then
              OppositeX := i;
              OppositeY := j;
            end if;
          end if;
        end loop;
      end loop;
      -- ܂΂Ƃ̊ԂׂēF
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (x < i) and (i < OppositeX) and (OppositeY < j) and (j < y) and (x + y = i + j) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      for i in 7 downto 0 loop
        for j in 7 downto 0 loop
          if (conv_integer(Ax) < i) and (i < x) and (y < j) and (j < conv_integer(Ay)) and (x + y = i + j) then
            if(SameColorData(i*8+j) = '0') then
              FillFlag := '0';
            end if;
          end if;
        end loop;
      end loop;
      if (OppositeX /= 8) and (OppositeY /= 8) and FillFlag = '1' then
        result <= '1';
      else
        result <= '0';
      end if;
    --------------------------------------------------------------------
    -- Internal Error
    --------------------------------------------------------------------
    else
      result <= '0';
    end if;
  end process;

end rtl;
