--
-- _A(x,y)ɐ΂łꂽꍇɗԂ_߂
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.global.all;

entity reversi_judge is
  port (
    Ax : in std_logic_vector(2 downto 0);
    Ay : in std_logic_vector(2 downto 0);
    Turn : in GameTurn;
    BlackData : in std_logic_vector(63 downto 0);
    WhiteData : in std_logic_vector(63 downto 0);
    ResultData : out std_logic_vector(63 downto 0)
    );
end reversi_judge;

architecture rtl of reversi_judge is
  
  component judge
    generic (
      x : integer := 0;
      y : integer := 0
      );
    port (
      Ax : in std_logic_vector(2 downto 0);
      Ay : in std_logic_vector(2 downto 0);
      Turn : in GameTurn;
      BlackData : in std_logic_vector(63 downto 0);
      WhiteData : in std_logic_vector(63 downto 0);
      result : out std_logic
      );
  end component;

begin

--  (progn (insert "-- begin auto generation\n") (let ((i 0) (j 0)) (while (< i 8) (progn (setq j 0) (while (< j 8) (progn (insert (format "  U%d%d : judge\n" i j)) (insert (format "    generic map(x=>%d, y=>%d)\n" i j)) (insert (format "    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(%d));\n" (+ (* i 8) j))) (setq j (+ j 1))))) (setq i (+ i 1)))) (insert "-- end auto generation\n"))-- begin auto generation
  U00 : judge
    generic map(x=>0, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(0));
  U01 : judge
    generic map(x=>0, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(1));
  U02 : judge
    generic map(x=>0, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(2));
  U03 : judge
    generic map(x=>0, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(3));
  U04 : judge
    generic map(x=>0, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(4));
  U05 : judge
    generic map(x=>0, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(5));
  U06 : judge
    generic map(x=>0, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(6));
  U07 : judge
    generic map(x=>0, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(7));
  U10 : judge
    generic map(x=>1, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(8));
  U11 : judge
    generic map(x=>1, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(9));
  U12 : judge
    generic map(x=>1, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(10));
  U13 : judge
    generic map(x=>1, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(11));
  U14 : judge
    generic map(x=>1, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(12));
  U15 : judge
    generic map(x=>1, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(13));
  U16 : judge
    generic map(x=>1, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(14));
  U17 : judge
    generic map(x=>1, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(15));
  U20 : judge
    generic map(x=>2, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(16));
  U21 : judge
    generic map(x=>2, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(17));
  U22 : judge
    generic map(x=>2, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(18));
  U23 : judge
    generic map(x=>2, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(19));
  U24 : judge
    generic map(x=>2, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(20));
  U25 : judge
    generic map(x=>2, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(21));
  U26 : judge
    generic map(x=>2, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(22));
  U27 : judge
    generic map(x=>2, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(23));
  U30 : judge
    generic map(x=>3, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(24));
  U31 : judge
    generic map(x=>3, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(25));
  U32 : judge
    generic map(x=>3, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(26));
  U33 : judge
    generic map(x=>3, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(27));
  U34 : judge
    generic map(x=>3, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(28));
  U35 : judge
    generic map(x=>3, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(29));
  U36 : judge
    generic map(x=>3, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(30));
  U37 : judge
    generic map(x=>3, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(31));
  U40 : judge
    generic map(x=>4, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(32));
  U41 : judge
    generic map(x=>4, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(33));
  U42 : judge
    generic map(x=>4, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(34));
  U43 : judge
    generic map(x=>4, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(35));
  U44 : judge
    generic map(x=>4, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(36));
  U45 : judge
    generic map(x=>4, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(37));
  U46 : judge
    generic map(x=>4, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(38));
  U47 : judge
    generic map(x=>4, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(39));
  U50 : judge
    generic map(x=>5, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(40));
  U51 : judge
    generic map(x=>5, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(41));
  U52 : judge
    generic map(x=>5, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(42));
  U53 : judge
    generic map(x=>5, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(43));
  U54 : judge
    generic map(x=>5, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(44));
  U55 : judge
    generic map(x=>5, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(45));
  U56 : judge
    generic map(x=>5, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(46));
  U57 : judge
    generic map(x=>5, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(47));
  U60 : judge
    generic map(x=>6, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(48));
  U61 : judge
    generic map(x=>6, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(49));
  U62 : judge
    generic map(x=>6, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(50));
  U63 : judge
    generic map(x=>6, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(51));
  U64 : judge
    generic map(x=>6, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(52));
  U65 : judge
    generic map(x=>6, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(53));
  U66 : judge
    generic map(x=>6, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(54));
  U67 : judge
    generic map(x=>6, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(55));
  U70 : judge
    generic map(x=>7, y=>0)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(56));
  U71 : judge
    generic map(x=>7, y=>1)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(57));
  U72 : judge
    generic map(x=>7, y=>2)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(58));
  U73 : judge
    generic map(x=>7, y=>3)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(59));
  U74 : judge
    generic map(x=>7, y=>4)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(60));
  U75 : judge
    generic map(x=>7, y=>5)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(61));
  U76 : judge
    generic map(x=>7, y=>6)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(62));
  U77 : judge
    generic map(x=>7, y=>7)
    port map(Ax=>Ax, Ay=>Ay, Turn=>Turn, BlackData=>BlackData, WhiteData=>WhiteData, result=>ResultData(63));
-- end auto generation


end rtl;
