// rs232c_txrs232c_rxV~[V邽߂̃eXgEx`
`timescale 1ns / 1ps

module rs232c_tx_rx_sim;
    parameter sys_clk = 14000000;
    parameter rate    = 9600;

    reg        clk, rst, wr;
    reg  [7:0] din;
    wire       dout, ready;

    wire       rx_rd;
    wire [7:0] rx_dout;

    reg [7:0]  data;
    
    rs232c_tx tx(.clk(clk), .rst(rst), .wr(wr), .din(din), .dout(dout), .ready(ready));
    rs232c_rx rx(.clk(clk), .rst(rst), .din(dout), .rd(rx_rd), .dout(rx_dout));
    
    initial begin
        clk = 0;
        forever #10 clk = !clk;
    end

    initial begin
        rst <= 0;
        #10;
        rst <= 1;
        #30;
        rst <= 0;
    end

    initial begin
        wr   = 0;
        data = 8'hz;
        din  = 8'hz;
        wait(rst);
        data = 8'h30;
        wait(!rst);
        forever begin
            wait (ready);
            wr   = 1;
            din  = data;
            data = data +1;
            wait (!ready);
            wr   = 0;
            din  = 8'hz;
        end
    end
    
endmodule
