-------------------------------------------------------------------------------
-- XORSHIFTˤ⥸塼
-- 
-- Copyright Takefumi MIYOSHI (c) 2008 All rights reserved.
--
-- $Id: xorshift.vhd 4383 2008-09-30 02:31:56Z miyo $
-------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

entity xorshift is

  port (
    pClk     : in  std_logic;
    pReset   : in  std_logic;
    pBusy    : out std_logic;
    pOutput  : out std_logic_vector(127 downto 0)
  );

end xorshift;

architecture RTL of xorshift is
  
  signal X : std_logic_vector(127 downto 0);
  signal Y : std_logic_vector(127 downto 0);
  signal Z : std_logic_vector(127 downto 0);
  signal W : std_logic_vector(127 downto 0);

  signal Q : std_logic_vector(127 downto 0);
  
begin

  pOutput <= Q;
  pBusy <= '0';

  process (pClk, pReset)
    variable T  : std_logic_vector(127 downto 0);
    variable WW : std_logic_vector(127 downto 0);
  begin
    if pReset = '1' then
      X <= conv_std_logic_vector(123456789, 128);
      Y <= conv_std_logic_vector(362436069, 128);
      Z <= conv_std_logic_vector(521288629, 128);
      W <= conv_std_logic_vector(88675123, 128);
    elsif pClk'event and pClk = '1' then
      T := X xor (X(116 downto 0) & "00000000000");
      X <= Y;
      Y <= Z;
      Z <= W;
      WW := (W xor ("0000000000000000000" & X(127 downto 19)))
            xor
            (T xor ("00000000" & X(127 downto 8)));
      Q <= WW;
      W <= WW;
    end if;
  end process;

end RTL;

