-------------------------------------------------------------------------------
-- XORSHIFTˤ⥸塼
--
-- unsigned long xor(){
--   static unsigned long y=2463534242;
--   y^=(y<<13); y^=(y>>17); return (y^=(y<<5));
-- }
-- 
-- http://www.jstatsoft.org/v08/i14/paper
-- 
-- Copyright Takefumi MIYOSHI (c) 2008 All rights reserved.
--
-- $Id: xorshift.vhd 4383 2008-09-30 02:31:56Z miyo $
-------------------------------------------------------------------------------

library IEEE;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

entity xorshift32 is

  port (
    pClk     : in  std_logic;
    pReset   : in  std_logic;
    Q        : out std_logic_vector(31 downto 0)
  );

end xorshift32;

architecture RTL of xorshift32 is

  -- (+ (* 37590 65536) 36002) = 2463534242
  -- signal Y : std_logic_vector(31 downto 0) := conv_std_logic_vector(2463534242, 32);
  signal Y : std_logic_vector(31 downto 0) := conv_std_logic_vector(37590, 16) & conv_std_logic_vector(36002, 16);
  
begin

  Q <= Y(31 downto 0);

  process (pClk, pReset)
    variable Y0  : std_logic_vector(31 downto 0);
    variable Y1 : std_logic_vector(31 downto 0);
  begin
    if pReset = '1' then
      Y <= conv_std_logic_vector(37590, 16) & conv_std_logic_vector(36002, 16);
    elsif pClk'event and pClk = '1' then
      Y0 := Y xor (Y(18 downto 0) & "0000000000000");
      Y1 := Y0 xor "00000000000000000" & Y0(31 downto 17);
      Y <= Y1 xor (Y1(26 downto 0) & "00000");
    end if;
  end process;

end RTL;
